/*********************************************************************/
/*																							*/
/*  TWILIGHT.H - Includedatei fr TwiLight-Schonermodule	  				*/
/*  Beginn:          16.03.1993													*/
/*																							*/
/*  Letzte nderung: 14.07.1993													*/
/*  																						*/
/*  Autor:           Arndt Weinmann												*/
/*                                                                   */
/*  Erweitert von Delirium Arts: 	15.4. 1994								*/
/*  																						*/
/*	Tabsize=3					 														*/
/********************************************************************/

#ifndef __TWILIGHT
#define __TWILIGHT

typedef struct{
	int	tl_version;
	int	tl_handle;
	int	max_x;
	int	max_y;
	int	vscr_x;
	int	vscr_y;
	int	vscr_w;
	int	vscr_h;
	int   max_colors;
	int	palette;
	int	planes;
	int   raster_op;
	long  cpu;
	long	fpu;
	long	mch;
	long	snd;
	long 	tl_screen_flag;
	char 	*tl_path_adr;
	void 	*tl_screen_adr;
	long 	tl_mem;
	long 	tl_aes_global;
	long 	tl_vdi_pb;
	int	tl_flags;
	int   cdecl	(*tl_check)(void);
	int   cdecl	(*tl_dim_col)(int value);
	int   cdecl	(*tl_mod_time)(void);
	void  cdecl	(*tl_set_col)(void *tab,int anzahl);
	void  cdecl	(*tl_scrn_restore)(void);
	int   cdecl	(*tl_wait)(int time);
	void  cdecl	(*tl_soundplay)(void *adr,long len,int mode);
	void  cdecl	(*tl_soundstop)(void);
	void  cdecl	(*tl_paula)(void *adr);
	long  cdecl	tl_reserved2[2];
	long  cdecl	(*tl_play_mouse)(void);
	int   cdecl	(*tl_scroll)(int anz,char *text);
	void  cdecl	(*tl_sprite_col)(void *tab,int anzahl);
	int   cdecl	(*tl_dither)(int planes,int breite,int hoehe,long tab,long ziel,long quelle);
	long  cdecl	(*tl_sprite_init)(long buffer,long buf_len,long obj_struct,int width,int height,int color_flag,int restore_flag);
	long  cdecl	(*tl_sprite)(int nummer);
	long  cdecl	(*tl_convert)(void *quelle,void *ziel,int breite,int hoehe,int planes,int *farbtab,int farben,int *dithertab);

}TL_INFO;


typedef struct
{
	int	length_of_xkonfig;
	void 	(*xroutine)(void);
	char 	*info_string;
	int 	number_of_objects;
	void 	*object1;
	void 	*objectn;
}XKONFIG;

typedef struct{
	long	tlm_magic;
	int   tlm_version;
	int 	tlm_min_acc;
	char  tlm_name[24];
	char  tlm_author[24];
	int	tlm_icon[48];
	long  tlm_mem_req;
	int	flags;
	XKONFIG *tlm_konfig;
}MODULE_INFO;

typedef struct{
	int     type;
	int     flag;
	int     (*click_routine)(void);
	int     state;
	int     x;
	int     y;
	char    *b_string;
}BUTTON;

typedef	signed int		SCODE;		/* Status Code */


/* Flags des Moduls	 (Handbuch Seite 25-26)				*/

#define TL_NOFLAG		0
#define TL_CHANGESCREEN 1
#define TL_CHANGECOLORS 2
#define TL_NEEDVSYNCS   4
#define TL_CLEARMOUSE   8
#define TL_DARKENSCREEN 16
#define TL_CLEARSCREEN  32
#define TL_NEEDSPRITES  64
#define TL_RESERVED     128
#define TL_NEEDMC020    256
#define TL_NEEDFPU      512
#define TL_PLAYSAMPLE   1024
#define TL_NOCHECK      4096



/* Makros */


#define _tl_version 		(tl_struct->tl_version)
#define _tl_handle 		(tl_struct->tl_handle)
#define _max_x				(tl_struct->max_x)
#define _max_y				(tl_struct->max_y)
#define _vscr_x			(tl_struct->vscr_x)
#define _vscr_y			(tl_struct->vscr_y)
#define _vscr_w			(tl_struct->vscr_w)
#define _vscr_h			(tl_struct->vscr_h)
#define _max_colors		(tl_struct->max_colors)
#define _palette			(tl_struct->palette)
#define _planes 			(tl_struct->planes)
#define _raster_op		(tl_struct->raster_op)
#define _cpu				(tl_struct->cpu)
#define _fpu				(tl_struct->fpu)
#define _mch				(tl_struct->mch)
#define _snd				(tl_struct->snd)
#define _tl_screen_flag	(tl_struct->tl_screen_flag)
#define _tl_path_adr		(tl_struct->tl_path_adr)
#define _tl_screen_adr	(tl_struct->tl_screen_adr)
#define _tl_mem			(tl_struct->tl_mem)
#define _tl_aes_global	(tl_struct->tl_aes_global)
#define _tl_vdi_pb		(tl_struct->tl_vdi_pb)
#define _tl_flags			(tl_struct->tl_flags)

#define tl_check			(tl_struct->tl_check)
#define tl_dim_col(value)	(tl_struct->tl_dim_col(value))
#define tl_mod_time		(tl_struct->tl_mod_time)
#define tl_set_col(tab,anzahl)	(tl_struct->tl_set_col(tab,anzahl))
#define tl_scrn_restore	(tl_struct->tl_scrn_restore)
#define tl_wait(time)	(tl_struct->tl_wait(time))
#define tl_soundplay(adr,len,mode) (tl_struct->tl_soundplay(adr,len,mode))
#define tl_soundstop	(tl_struct->tl_soundstop)
#define tl_paula(adr)	(tl_struct->tl_paula(adr))
#define tl_play_mouse	(tl_struct->tl_play_mouse)
#define tl_scroll(anz,text) (tl_struct->tl_scroll(anz,text))
#define tl_dither(planes,breite,hoehe,tab,ziel,quelle) (tl_struct->(planes,breite,hoehe,tab,ziel,quelle))
#define tl_sprite_init(buffer,buf_len,obj_struct,width,height,color_flag,restore_flag) (tl_struct->tl_sprite_init(buffer,buf_len,obj_struct,width,height,color_flag,restore_flag)
#define tl_sprite(num) (tl_struct->tl_sprite(num))
#define tl_convert(quelle,ziel,breite,hoehe,planes,farbtab,farben,dithertab) (tl_struct->tl_convert(quelle,ziel,breite,hoehe,planes,farbtab,farben,dithertab))



#endif
