/*
*
* Header for a "shared library"
* Is used in place of the Start codes of PureC
*
* It is _imperative_ to ensure that bit 3 of the flags 
* in the program header is set to prevent the library
* reserving the whole of available memory.
*
* Tabulator width: 5
*
* Andreas Kromke
* 24.1.98
*
*/

	XREF	slb_init
	XREF slb_exit
	XREF slb_open
	XREF slb_close
	XREF	slb_fn0
	XDEF	__text

	TEXT

__text:
DC.L		$70004afc			; Magic value
DC.L		name				; Pointer to name of library
DC.L		1				; Version number
DC.L		0				; Flags, at present 0L
DC.L		slb_init			; Is called after loading
DC.L		slb_exit			; Is called before exit/removal
DC.L		slb_open			; Is called at opening
DC.L		slb_close			; Is called at closing
DC.L		0				; Pointer to procedure name (optional)
DC.L		0,0,0,0,0,0,0,0	; Unused, always NULL
DC.L		0				; Number of functions (none!)

name:		DC.B	'WINFRAME.SLB',0

	END