/*--------------------------------------------------------------------------*/
/*	File name:	SAVE_IP.C						Revision date:	1999.11.28	*/
/*	Revised by:	Ulf Ronald Andersson			Revision start:	1999.11.28	*/
/*	Created by:	Peter Rottengatter				Creation date:	1997.10.18	*/
/*--------------------------------------------------------------------------*/
/*	Purpose:	Save connected IP address to allow restart, still connected	*/
/*--------------------------------------------------------------------------*/
#include	<aes.h>
#include	<tos.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<stdio.h>
#include	<string.h>

#include	"sting\transprt.h"
#include	"sting\port.h"
/*--------------------------------------------------------------------------*/
long	get_sting_cookie (void);
void	do_some_work (void);


DRV_LIST	*sting_drivers;
STX			*stx;

char	*path, port_name[32] = "";

char	bad_arguments[] =
			"[1][ | Use 2 args: file + port][ Ok ]";
char	STinG_not_there[] =
			"[1][ | STinG not loaded and active!][ Hmmm ]";
char	STinG_corrupted[] =
			"[1][ | STinG structures corrupted !][ Oooops ]";
char	use_STinG_not_STiK[] =
			"[1][ | You need STinG, not STiK !][ Oooops ]";
char	no_open[]   =
			"[1][ | Can\'t create file \'IP.INF\' !][ Shit ]";
/*--------------------------------------------------------------------------*/
void	exit_with_alert(char *alert_string);
/*--------------------------------------------------------------------------*/
void main (int argc, char *argv[])

{	int  count;

	appl_init();

	if	(argc < 3)
		exit_with_alert (bad_arguments);

	path = argv[1];

	for (count = 2; count < argc; count++)
	{	strcat (port_name, argv[count]);
		if	(count < argc - 1)   strcat (port_name, " ");
	}

	sting_drivers = (DRV_LIST *) Supexec (get_sting_cookie);
	if	(sting_drivers == 0L)
		exit_with_alert (STinG_not_there);

	if	(strcmp (sting_drivers->magic, MAGIC) != 0)
		exit_with_alert (STinG_corrupted);

	stx = (STX *) (*sting_drivers->get_dftab) (MODULE_DRIVER);
	if	(stx == (STX *) NULL)
		exit_with_alert (use_STinG_not_STiK);

	do_some_work();
	appl_exit();
}
/*------------------*/
/*	ends:	main	*/
/*--------------------------------------------------------------------------*/
void	exit_with_alert(char *alert_string)
{	form_alert (1, alert_string);
	appl_exit();
	exit(-1);
}
/*------------------------------*/
/*	ends:	exit_with_alert		*/
/*--------------------------------------------------------------------------*/
long  get_sting_cookie()

{	long  *work;

	for (work = * (long **) 0x5a0L; *work != 0L; work += 2)
		if	(*work == 'STiK')
			return (*++work);
	return (0L);
}
/*------------------------------*/
/*	ends:	get_sting_cookie	*/
/*--------------------------------------------------------------------------*/
void  do_some_work()

{	PORT    *chain;
	uint32  ip;
	int16   file;
	void    *dummy;
	char    *name, ip_addr[20];

	if	(path[1] == ':')
	{	Dsetdrv (toupper (path[0]) - 'A');
		path = & path[2];
	}
	name = path;

	if	(strrchr (path, '\\') == NULL)
		Dsetpath ("\\");
	else
	{	* ((name = strrchr (path, '\\') + 1) - 1) = '\0';
		Dsetpath (path);
	}

	if	((file = (int16) Fcreate (name, 0)) < 0)
	{	form_alert (1, no_open);
		return;
	}

	query_chains ((void **) & chain, & dummy, & dummy);
	while (chain != NULL)
	{	if (strcmp (chain->name, port_name) == 0)
		{	ip = chain->ip_addr;
			sprintf (ip_addr, "%ld.%ld.%ld.%ld\r\n", (ip >> 24) & 0xff, (ip >> 16) & 0xff, (ip >> 8) & 0xff, ip & 0xff);
			Fwrite (file, strlen (ip_addr), ip_addr);
		}
		chain = chain->next;
	}
	Fclose (file);
}
/*--------------------------*/
/*	ends:	do_some_work	*/
/*--------------------------------------------------------------------------*/
/*	End of file:	SAVE_IP.C												*/
/*--------------------------------------------------------------------------*/
