; /-----------------------------------------------------------------------/
; file:		bios.s
; function:	Bios macros
; opcode:		
; part of:	General Merciful Software development.
;
; author:		E Kuik
; company:	Merciful Software (1997)
; /-----------------------------------------------------------------------/

.ifnb bios
bios	=	13

dev_printer	=	0
dev_aux		=	1
dev_console	=	2
dev_midi		=	3
dev_ikbd		=	4
dev_raw		=	5

recsiz		=	0
clsiz		=	2
clsizb		=	4
rdlen		=	6
fsiz		=	8
fatrec		=	10
datrec		=	12
numcl		=	14
bflags		=	16

k_rshift		=	1
k_lshift		=	2
k_ctrl		=	4
k_alt		=	8
k_capslock	=	16
k_clrhome		=	32
k_insert		=	64

.endif

.macro Bconin dev
	move.w	dev,-(sp)
	move.w	#2,-(sp)
	trap	#bios
	addq.l	#4,sp
.endm

.macro Bconout dev,ch
	move.w	ch,-(sp)
	move.w	dev,-(sp)
	move.w	#3,-(sp)
	trap	#bios
	addq.l	#6,sp
.endm

.macro Bconstat dev
	move.w	dev,-(sp)
	move.w	#1,-(sp)
	trap	#bios
	addq.l	#4,sp
.endm

.macro Bcostat dev
	move.w	dev,-(sp)
	move.w	#8,-(sp)
	trap	#bios
	addq.l	#4,sp
.endm

.macro Drvmap
	move.w	#$0a,-(sp)
	trap	#bios
	add.l	#2,sp
.endm

.macro Getbpb dev
	move.w	dev,-(sp)
	move.w	#7,-(sp)
	trap	#bios
	addq.l	#4,sp
.endm

.macro Getmpb mpb
	move.l	mpb,-(sp)
	clr.w	-(sp)
	trap	#bios
	addq.l	#6,sp
.endm

.macro Kbshift mode
	move.w	mode,-(sp)
	move.w	#$0b,-(sp)
	trap	#bios
	addq.l	#4,sp
.endm

.macro Mediach dev
	move.w	dev,-(sp)
	move.w	#9,-(sp)
	trap	#bios
	addq.l	#4,sp
.endm

.macro Rwabs mode,buf,count,recno,dev,lrecno
	move.l	lrecno,-(sp)
	move.w	dev,-(sp)
	move.w	recno,-(sp)
	move.w	count,-(sp)
	move.l	buf,-(sp)
	move.w	mode,-(sp)
	move.w	#4,-(sp)
	trap	#bios
	lea	18(sp),sp
.endm

.macro Setexc num,newvec
	move.l	newvec,-(sp)
	move.w	num,-(sp)
	move.w	#5,-(sp)
	trap	#bios
	addq.l	#8,sp
.endm

.macro Tickcal
	move.w	#6,-(sp)
	trap	#bios
	addq.l	#2,sp
.endm
