; /-----------------------------------------------------------------------/
; file:		gemdos.s
; function:	Gemdos macros
; opcode:		
; part of:	General Merciful Software development.
;
; author:		E Kuik
; company:	Merciful Software (1997)
; /-----------------------------------------------------------------------/

.ifnb gemdos
gemdos	=	1

.macro Cauxin
	move.w	#$03,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cauxis
	move.w	#$12,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cauxos
	move.w	#$13,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cauxout ch
	move.w	ch,-(sp)
	move.w	#4,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Cconin
	move.w	#1,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cconis
	move.w	#$b,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cconos
	move.w	#$10,-(sp)
	trap	#gemdos
	addq.w	#2,sp
.endm

.macro Cconout ch
	move.w	ch,-(sp)
	move.w	#2,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Cconrs str
	move.l	str,-(sp)
	move.w	#$0a,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Cconws str
	move.l	str,-(sp)
	move.w	#$09,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Cnecin
	move.w	#$08,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cprnos
	move.w	#$11,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Cprnout ch
	move.w	ch,-(sp)
	move.w	#$05,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Crawin
	move.w	#$07,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Crawio ch
	move.w	ch,-(sp)
	move.w	#$06,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Dclosedir dirhandle
	move.l	dirhandle,-(sp)
	move.w	#$12b,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Dcntl arg,name,cmd
	move.l	arg,-(sp)
	move.l	name,-(sp)
	move.w	cmd,-(sp)
	move.w	#$130,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Dcreate path
	move.l	path,-(sp)
	move.w	#$39,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Ddelete path
	move.l	path,-(sp)
	move.w	#$3a,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Dfree drive,info
	move.w	drive,-(sp)
	move.l	info,-(sp)
	move.w	#$36,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Dgetcwd path,size,drv
	move.l	path,-(sp)
	move.w	size,-(sp)
	move.w	drv,-(sp)
	move.w	#$13b,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Dgetdrv
	move.w	#$19,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Dgetpath path,drv
	move.w	drv,-(sp)
	move.l	path,-(sp)
	move.w	#$47,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Dlock drv,mode
	move.w	drv,-(sp)
	move.w	mode,-(sp)
	move.w	#$135,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Dopendir flag,name
	move.w	flag,-(sp)
	move.l	name,-(sp)
	move.w	#$128,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Dpathconf mode,name
	move.w	mode,-(sp)
	move.l	name,-(sp)
	move.w	#$124,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Dreaddir buf,dirhandle,len
	move.l	buf,-(sp)
	move.l	dirhandle,-(sp)
	move.w	len,-(sp)
	move.w	#$129,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Drewinddir handle
	move.l	handle,-(sp)
	move.w	#$12a,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Dsetdrv drive
	move.w	drive,-(sp)
	move.w	#$0e,-(sp)
	trap	#gemdos
	addq.w	#4,sp
.endm

.macro Dsetpath path
	move.l	path,-(sp)
	move.w	#$3b,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Fattrb attr,flag,fname
	move.w	attr,-(sp)
	move.w	flag,-(sp)
	move.l	fname,-(sp)
	move.w	#$43,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fchmod mode,name
	move.w	mode,-(sp)
	move.l	name,-(sp)
	move.w	#$132,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Fchown gid,uid,name
	move.w	gid,-(sp)
	move.w	uid,-(sp)
	move.l	name,-(sp)
	move.w	#$131,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fclose handle
	move.w	handle,-(sp)
	move.w	#$3e,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Fcntl cmd,arg,handle
	move.w	cmd,-(sp)
	move.l	arg,-(sp)
	move.w	handle,-(sp)
	move.w	#$260,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fcreate attr,fname
	move.w	attr,-(sp)
	move.l	fname,-(sp)
	move.w	#$3c,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Fdatime flag,handle,timeptr
	move.w	flag,-(sp)
	move.w	handle,-(sp)
	move.l	timeptr,-(sp)
	move.w	#$57,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fdelete fname
	move.l	fname,-(sp)
	move.w	#$41,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Fdup shandle
	move.w	shandle,-(sp)
	move.w	#$45,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Fforce nhandle,shandle
	move.w	nhandle,-(sp)
	move.w	shandle,-(sp)
	move.w	#$46,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Fgetchar mode,handle
	move.w	mode,-(sp)
	move.w	handle,-(sp)
	move.w	#$107,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Fgetdta
	move.w	#$2f,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Finstat handle
	move.w	handle,-(sp)
	move.w	#$105,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Flink newname,oldname
	move.l	newname,-(sp)
	move.l	oldname,-(sp)
	move.w	#$12d,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Flock length,start,mode,handle
	move.l	length,-(sp)
	move.l	start,-(sp)
	move.w	mode,-(sp)
	move.w	handle,-(sp)
	move.w	#$5c,-(sp)
	trap	#gemdos
	lea	14(sp),sp
.endm

.macro Fmidipipe out,in,pid
	move.w	out,-(sp)
	move.w	in,-(sp)
	move.w	pid,-(sp)
	move.w	#$126,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Fopen mode,fname
	move.w	mode,-(sp)
	move.l	fname,-(sp)
	move.w	#$3d,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Foutstat handle
	move.w	handle,-(sp)
	move.w	#$106,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Fpipe fhandle
	move.l	fhandle,-(sp)
	move.w	#$100,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Fputchar mode,lchar,handle
	move.w	mode,-(sp)
	move.l	lchar,-(sp)
	move.w	handle,-(sp)
	move.w	#$108,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fread buf,length,handle
	move.l	buf,-(sp)
	move.l	length,-(sp)
	move.w	handle,-(sp)
	move.w	#$3f,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Freadlink name,buf,bufsiz
	move.l	name,-(sp)
	move.l	buf,-(sp)
	move.w	bufsiz.-(sp)
	move.w	#$12f,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Frename newname,oldname
	move.l	newname,-(sp)
	move.l	oldname,-(sp)
	clr.w	-(sp)
	move.w	#$56,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Fseek mode,handle,offset
	move.w	mode,-(sp)
	move.w	handle,-(sp)
	move.l	offset,-(sp)
	move.w	#$42,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fselect wfds,rfds,timeout
	clr.l	-(sp)
	move.l	wfds,-(sp)
	move.l	rfds,-(sp)
	move.w	timeout,-(sp)
	move.w	#$11d,-(sp)
	trap	#gemdos
	lea	16(sp),sp
.endm

.macro Fsetdta ndta
	move.l	ndta,-(sp)
	move.w	#$1a,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Fsfirst fspec,attr
	move.w	attr,-(sp)
	move.l	fspec,-(sp)
	move.w	#$4e,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Fsnext
	move.w	#$4f,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Fsymlink newname,oldname
	move.l	newname,-(sp)
	move.l	oldname,-(sp)
	move.w	#$12e,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Fwrite buf,count,handle
	move.l	buf,-(sp)
	move.l	count,-(sp)
	move.w	handle,-(sp)
	move.w	#$40,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Fxattr xattr,name,flag
	move.l	xattr,-(sp)
	move.l	name,-(sp)
	move.w	flag,-(sp)
	move.w	#$12c,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Maddalt size,start
	move.l	size,-(sp)
	move.l	start,-(sp)
	move.w	#$14,-(sp)
	trap	#gemdos
	lea	10(sp),sp
.endm

.macro Malloc amount
	move.l	amount,-(sp)
	move.w	#$48,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Mfree start
	move.l	start,-(sp)
	move.w	#$49,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Mshrink newsize,start
	move.l	newsize,-(sp)
	move.l	start,-(sp)
	clr.w	-(sp)
	move.w	#$4a,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Mxalloc mode,amount
	move.w	mode,-(sp)
	move.l	amount,-(sp)
	move.w	#$44,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Pause
	move.w	#$121,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pdomain domain
	move.w	domain,-(sp)
	move.w	#$119,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Pexec envstr,cmdline,fname,mode
	move.l	envstr,-(sp)
	move.l	cmdline,-(sp)
	move.l	fname,-(sp)
	move.w	mode,-(sp)
	move.w	#$4b,-(sp)
	trap	#gemdos
	lea	16(sp),sp
.endm

.macro Pfork
	move.w	#$11b,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pgetegid
	move.w	#$139,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pgeteuid
	move.w	#$138,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pgetgid
	move.w	#$10f,-(sp)
	trap	#gemdos
	addq.l	#2,-(sp)
.endm

.macro Pgetpgrp
	move.w	#$10d,-(sp)
	trap	#gemdos
	addq.l	#2,-(sp)
.endm

.macro Pgetpid
	move.w	#$10b,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pgetppid
	move.w	#$10c,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pgetuid
	move.w	#$10f,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pkill sid,pid
	move.w	sid,-(sp)
	move.w	pid,-(sp)
	move.w	#$111,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Pmsg msgptr,mboxid,mode
	move.l	msgptr,-(sp)
	move.l	mboxid,-(sp)
	move.w	mode,-(sp)
	move.w	#$125,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Pnice delta
	move.w	delta,-(sp)
	move.w	#$10a,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Prenice delta,pid
	move.w	delta,-(sp)
	move.w	pid,-(sp)
	move.w	#$127,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Prusage rusg
	move.l	rusg,-(sp)
	move.w	#$11e,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Psemaphore timeout,id,mode
	move.l	timeout,-(sp)
	move.l	id,-(sp)
	move.w	mode,-(sp)
	move.w	#$134,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Psetgid gid
	move.w	gid,-(sp)
	move.w	#$115,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Psetlimit value,limit
	move.l	value,-(sp)
	move.w	limit,-(sp)
	move.w	#$11f,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Psetpgrp newgrp,pid
	move.w	newgrp,-(sp)
	move.w	pid,-(sp)
	move.w	#$10e,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Psetuid uid
	move.w	uid,-(sp)
	move.w	#$110,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Psigaction sig,act,oact
	move.w	sig,-(sp)
	move.l	act,-(sp)
	move.l	oact,-(sp)
	move.w	#$137,-(sp)
	trap	#gemdos
	lea	12(sp),sp
.endm

.macro Psigblock mask
	move.l	mask,-(sp)
	move.w	#$116,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Psignal handler,sig
	move.l	handler,-(sp)
	move.w	sig,-(sp)
	move.w	#$112,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Psigpause mask
	move.l	mask,-(sp)
	move.w	#$136,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Psigpending
	move.w	#$123,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Psigreturn
	move.w	#$11a,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Psigsetmask mask
	move.l	mask,-(sp)
	move.w	#$117,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Pterm retcode
	move.w	retcode,-(sp)
	move.w	#$4c,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Pterm0
	clr.w	-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Ptermres retcode,keep
	move.w	retcode,-(sp)
	move.l	keep,-(sp)
	move.w	#$31,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Pumask mode
	move.w	mode,-(sp)
	move.w	#$133,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Pusrval
	move.w	#$118,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pvfork
	move.w	#$113,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pwait
	move.w	#$109,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Pwait3 rusage,flag
	move.l	rusage,-(sp)
	move.w	flag,-(sp)
	move.w	#$11c,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Pwaitpid rusage,flag
	move.l	rusage,-(sp)
	move.w	flag,-(sp)
	move.w	#$13a,-(sp)
	trap	#gemdos
	addq.l	#8,sp
.endm

.macro Salert str
	move.l	str,-(sp)
	move.w	#$13c,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Super stack
	move.l	stack,-(sp)
	move.w	#$20,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Sversion
	move.w	#$30,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Syield
	move.w	#$ff,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Sysconf inq
	move.w	inq,-(sp)
	move.w	#$122,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Talarm time
	move.l	time,-(sp)
	move.w	#$120,-(sp)
	trap	#gemdos
	addq.l	#6,sp
.endm

.macro Tgetdate
	move.w	#$2a,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Tgettime
	move.w	#$2c,-(sp)
	trap	#gemdos
	addq.l	#2,sp
.endm

.macro Tsetdate date
	move.w	date,-(sp)
	move.w	#$2b,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.macro Tsettime time
	move.w	time,-(sp)
	move.w	#$2d,-(sp)
	trap	#gemdos
	addq.l	#4,sp
.endm

.endif