; /-----------------------------------------------------------------------/
; file:		tos.i
; function:	Operatin system macros
; opcode:		
; part of:	General Merciful Software development.
;
; author:		E Kuik
; company:	Merciful Software (1997)
; /-----------------------------------------------------------------------/

.ifnb TOS

.ifnb gemdos
.include "gemdos.i"
.endif

.ifnb bios
.include "bios.i"
.endif

.ifnb xbios
.include "xbios.i"
.endif

.ifnb etv_timer
/* legal system addresses */
etv_timer		=	$400
etv_critic	=	$404
etv_term		=	$408
etv_xtra		=	$40c
memvalid		=	$420
memcntlr		=	$424
resvalid		=	$426
res_magic		=	$31415926
resvector		=	$42a
phystop		=	$42e
_membot		=	$432
_memtop		=	$436
memval2		=	$43a
_flock		=	$43e
seekrate		=	$440
_timr_ms		=	$442
_fverify		=	$444
_bootdev		=	$446
palmode		=	$448
defshiftmd	=	$44a
sshiftmd		=	$44c
_v_bas_ad		=	$44e
vblsem		=	$452
nvbls		=	$454
_vblqueue		=	$456
colorptr		=	$45a
screenpt		=	$45e
_vbclock		=	$462
_frclock		=	$466
hdv_init		=	$46a
swv_vec		=	$46e
hdv_bpb		=	$472
hdv_rw		=	$476
hdv_boot		=	$47a
hdv_mediach	=	$47e
_cmdload		=	$482
conterm		=	$484
themd		=	$48e
_md		=	$4a2
savptr		=	$4a2
_nflops		=	$4a6
sav_context	=	$4ae
_bufl		=	$4b2
_hz_200		=	$4ba
the_env		=	$4be
_drvbits		=	$4c2
_dskbufp		=	$4c6
_prt_cnt		=	$4ee
_sysbase		=	$4f2
_shell_p		=	$4f6
end_os		=	$4fa
exec_os		=	$4fe
pun_ptr		=	$516
_p_cookies	=	$5a0
proc_lives	=	$380	; $12345678 iff valid
proc_dregs	=	$384	; saved D0-D7
proc_aregs	=	$3a4	; saved A0-A6,supervisor A7 (SSP)
proc_enum		=	$3c4	; first byte is exception #
proc_usp		=	$3c8	; saved user A7
proc_stk		=	$3cc	; sixteen words popped from SSP

/* aline offsets */
cur_font		=	-906
m_pos_hx		=	-856
m_pos_hy		=	-854
m_planes		=	-852
m_cdb_bg		=	-850
m_cdb_fg		=	-848
mask_form		=	-846
inq_tab		=	-782
dev_tab		=	-692
gcurx		=	-602
gcury		=	-600
m_hid_ct		=	-598
mouse_bt		=	-596
req_col		=	-594
siz_tab		=	-498
cur_work		=	-464
def_font		=	-460
font_ring		=	-456
font_count	=	-440
cur_ms_stat	=	-348
v_hid_cnt		=	-346
cur_x		=	-344
cur_y		=	-342
cur_flag		=	-340
mouse_flag	=	-339
v_sav_xy		=	-334
save_len		=	-330
save_addr		=	-328
save_stat		=	-324
save_area		=	-322
user_tim		=	-66
next_tim		=	-62
user_but		=	-58
user_col		=	-54
user_mot		=	-50
v_cel_ht		=	-46
v_cel_mx		=	-44
v_cel_my		=	-42
v_cel_wr		=	-40
v_cel_bg		=	-38
v_cel_fg		=	-36
v_cur_ad		=	-34
v_cur_of		=	-30
v_cur_xy		=	-28
v_period		=	-24
v_cur_ct		=	-23
v_fnt_ad		=	-22
v_fnt_nd		=	-18
v_fnt_st		=	-16
v_fnt_wd		=	-14
v_rez_hz		=	-12
v_off_ad		=	-10
v_rez_vt		=	-4
bytes_lin		=	-2
planes		=	0
width		=	2

/* dta offsets */
d_reserved	=	0
d_attrib		=	21
d_time		=	22
d_date		=	24
d_length		=	26
d_fname		=	30

/* macro's */
/* for mxalloc modes */
mx_stram		=	0
mx_ttram		=	1
mx_prefstram	=	2
mx_prefttram	=	3

.endif


.ifnb cr
cr	=	$0d
lf	=	$0a
spatie	=	$20
.endif

/* Extra system calls (macro's) */

* get a memory block
.macro Xmalloc mode,amount,buffer
	move.l	d1,-(sp)
	move.l	amount,d0
	move.w	mode,d1
	jsr	_Xmalloc
	move.l	(sp)+,d1
	move.l	d0,buffer
.endm

* get free memory
.macro Mgfree
	Malloc	#-1
.endm

.macro Xmgfree mode
	Xmalloc	mode,#-1,d0
.endm

* string manipulation
.macro Clear_str str
	move.l	str,a0
	jsr	_clear_str
.endm

.macro End_str str1,str2
	move.l	str1,a0
	jsr	_end_str
.ifnb str2
	move.l	a0,str2
.endif
.endm

.macro Copy_str str1,str2
	move.l	str1,a1
	move.l	str2,a0
	jsr	_copy_str
.endm

.macro Find_str str,env
	move.l	str,a0
	move.l	env,a1
	jsr	_find_str
.endm

.macro Find_env str,env
	move.l	str,a0
	move.l	env,a1
	jsr	_find_env
.endm

.macro Lower_str str
	move.l	str,a0
	jsr	_lower_str
.endm

.macro Upper_str str
	move.l	str,a0
	jsr	_upper_str
.endm

.macro Merge_str str1,str2
	move.l	str1,a0
	move.l	str2,a1
	jsr	_merge_str
.endm

.macro Reboot
	Super	#0
	jmp	_reboot
.endm
* extra machine instruktions
.macro pull reg
	move.l	(sp)+,reg
.endm

.macro Xlink reg,dat
	pea	(reg)
	move.l	sp,reg
	add.l	dat,reg
.endm

.macro push dat
	move.l	dat,-(sp)
.endm

* strange stuff
.macro Wait_key key
	Bconin	#2
	move.w	d0,key
.endm

* return to startup file
.macro Return errcode
	move.l	errcode,d0
	rts
.endm

.macro Get_cookie cookie,value
	move.l	cookie,d0
	jsr	_Get_Cookie
	move.l	d1,value
	tst.l	d0
.endm

TOS		=	1
.endif