; /-----------------------------------------------------------------------/
; file:		xbios.s
; function:	Xbios macros
; opcode:		
; part of:	General Merciful Software development.
;
; author:		E Kuik
; company:	Merciful Software (1997)
; /-----------------------------------------------------------------------/

.ifnb xbios
xbios	=	14

; color pallette index
White	=	0
Red	=	1
Green	=	2
Yellow	=	3
Blue	=	4
Magneta	=	5
Cyan	=	6
Lgray	=	7
Dgray	=	8
Lred	=	9
Lgreen	=	10
Lyellow	=	11
Lblue	=	12
Lmagneta	=	13
Lcyan	=	14
Black	=	15

; pallete settings normal ST
ST_White		=	$0777
ST_Red		=	$0700
ST_Green		=	$0070
ST_Yellow		=	$0770
ST_Blue		=	$0007
ST_Magneta	=	$0707
ST_Cyan		=	$0077
ST_Lgray		=	$0555
ST_Dgray		=	$0333
ST_Lred		=	$0733
ST_Lgreen		=	$0373
ST_Lyellow	=	$0773
ST_Lblue		=	$0337
ST_Lmagneta	=	$0737
ST_Lcyan		=	$0377
ST_Black		=	$0000


.macro Bconmap devno
	move.w	devno,-(sp)
	move.w	#$2c,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Bioskeys
	move.w	#$18,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Blitmode mode
	move.w	mode,-(sp)
	move.w	#$40,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Buffoper mode
	move.w	mode,-(sp)
	move.w	#$88,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Buffptr sptr
	move.l	sptr,-(sp)
	move.w	#$8d,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Cursconf rate,mode
	move.w	rate,-(sp)
	move.w	mode,-(sp)
	move.w	#$15,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Dbmsg msg_arg,msg_num
	move.l	msg_arg,-(sp)
	move.w	msg_num,-(sp)
	move.w	#$5,-(sp)
	move.w	#$0b,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro Devconnect protocol,prescale,clk,dest,source
	move.w	protocol,-(sp)
	move.w	prescale,-(sp)
	move.w	clk,-(sp)
	move.w	dest,-(sp)
	move.w	source,-(sp)
	move.w	#$8b,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro DMAread dev,buf,count,sector
	move.w	dev,-(sp)
	move.l	buf,-(sp)
	move.w	count,-(sp)
	move.l	sector,-(sp)
	move.w	#$2a,-(sp)
	trap	#xbios
	lea	14(sp),sp
.endm

.macro DMAwrite dev,buf,count,sector
	move.w	dev,-(sp)
	move.l	buf,-(sp)
	move.w	count,-(sp)
	move.l	sector,-(sp)
	move.w	#$2b,-(sp)
	trap	#xbios
	lea	14(sp),sp
.endm

.macro Dosound cmdlist
	move.l	cmdlist,-(sp)
	move.w	#$20,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Dsp_Available yavail,xavail
	move.l	yavail,-(sp)
	move.l	xavail,-(sp)
	move.w	#$6a,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro Dsp_BlkBytes size_out,data_out,size_in,data_in
	move.l	size_out,-(sp)
	move.l	data_out,-(sp)
	move.l	size_in,-(sp)
	move.l	data_in,-(sp)
	move.w	#$7c,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_HandShake size_out,data_out,size_in,data_in
	move.l	size_out,-(sp)
	move.l	data_out,-(sp)
	move.l	size_in,-(sp)
	move.l	data_in,-(sp)
	move.w	#$61,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_BlkUnpacked size_out,data_out,size_in,data_in
	move.l	size_out,-(sp)
	move.l	data_out,-(sp)
	move.l	size_in,-(sp)
	move.l	data_in,-(sp)
	move.w	#$62,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_BlkWords size_out,data_out,size_in,data_in
	move.l	size_out,-(sp)
	move.l	data_out,-(sp)
	move.l	size_in,-(sp)
	move.l	data_in,-(sp)
	move.w	#$7b,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_DoBlock size_out,data_out,size_in,data_in
	move.l	size_out,-(sp)
	move.l	data_out,-(sp)
	move.l	size_in,-(sp)
	move.l	data_in,-(sp)
	move.w	#$60,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_ExecBoot ability,codesize,codeptr
	move.w	ability,-(sp)
	move.l	codesize,-(sp)
	move.l	codeptr,-(sp)
	move.w	#$6e,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Dsp_ExecProg ability,codesize,codeptr
	move.w	ability,-(sp)
	move.l	codesize,-(sp)
	move.l	codeptr,-(sp)
	move.w	#$6d,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Dsp_FlushSubroutines
	move.w	#$73,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_GetProgAbility
	move.w	#$72,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_GetWordSize
	move.w	#$67,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_Hf0 flag
	move.w	flag,-(sp)
	move.w	#$77,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Dsp_Hf1 flag
	move.w	flag,-(sp)
	move.w	#$78,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Dsp_Hf2
	move.w	#$79,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_Hf3
	move.w	#$7a,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_HStat
	move.w	#$7d,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_InqSubrAbility ability
	move.w	ability,-(sp)
	move.w	#$75,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Dsp_InStream blocks_done,num_blocks,block_size,data_in
	move.l	blocks_done,-(sp)
	move.l	num_blocks,-(sp)
	move.l	block_size,-(sp)
	move.l	data_in,-(sp)
	move.w	#$63,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_IOStream blocks_done,num_blocks,block_outsize,block_insize,data_out,data_in
	move.l	blocks_done,-(sp)
	move.l	num_blocks,-(sp)
	move.l	block_outsize,-(sp)
	move.l	block_insize,-(sp)
	move.l	data_out,-(sp)
	move.l	data_in,-(sp)
	move.w	#$65,-(sp)
	trap	#xbios
	lea	26(sp),sp
.endm

.macro DspLoadProg buf,ability,file
	move.l	buf,-(sp)
	move.w	ability,-(sp)
	move.l	file,-(sp)
	move.w	#$6c,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Dsp_LoadSubroutine ability,size,ptr
	move.w	ability,-(sp)
	move.l	size,-(sp)
	move.l	ptr,-(sp)
	move.w	#$74,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Dsp_Lock
	move.w	#$68,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_LodToBinary codeptr,file
	move.l	codeptr,-(sp)
	move.l	file,-(sp)
	move.w	#$6f,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro Dsp_MultBlocks receiveblks,sendblks,numreceive,numsend
	move.l	receiveblks,-(sp)
	move.l	sendblks,-(sp)
	move.l	numreceive,-(sp)
	move.l	numsend,-(sp)
	move.w	#$7f,-(sp)
	trap	#xbios
	lea	20(sp),sp
.endm

.macro Dsp_OutStream blocks_done,num_blocks,block_size,data_out
	move.l	blocks_done,-(sp)
	move.l	num_blocks,-(sp)
	move.l	block_size,-(sp)
	move.l	data_out,-(sp)
	move.w	#$64,-(sp)
	trap	#xbios
	lea	18(sp),sp
.endm

.macro Dsp_RemoveInterrupts mask
	move.w	mask,-(sp)
	move.w	#$66,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Dsp_RequestUniqueAbility
	move.w	#$71,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsp_Reserve yreserve,xreserve
	move.l	yreserve,-(sp)
	move.l	xreserve,-(sp)
	move.w	#$6b,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro Dsp_RunSubroutine handle
	move.w	handle,-(sp)
	move.w	#$76,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Dsp_SetVectors transmitter,receiver
	move.l	transmitter,-(sp)
	move.l	receiver,-(sp)
	move.w	#$7e,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro Dsp_TriggerHC vector
	move.w	vector,-(sp)
	move.w	#$70,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Dsp_Unlock
	move.w	#$69,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Dsptristate dsprec,dspxmit
	move.w	dsprec,-(sp)
	move.w	dspxmit,-(sp)
	move.w	#$89,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro EgetPalette palette,count,start
	move.l	palette,-(sp)
	move.w	count,-(sp)
	move.w	start,-(sp)
	move.w	#$55,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro EgetShift
	move.w	#$51,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro EsetBank bank
	move.w	bank,-(sp)
	move.w	#$52,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro EsetColor color,idx
	move.w	color,-(sp)
	move.w	idx,-(sp)
	move.w	#$53,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro EsetGray mode
	move.w	mode,-(sp)
	move.w	#$56,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Esetpalette palette,count,start
	move.l	palette,-(sp)
	move.w	count,-(sp)
	move.w	start,-(sp)
	move.w	#$54,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro EsetShift mode
	move.w	mode,-(sp)
	move.w	#$50,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro EsetSmear mode
	move.w	mode,-(sp)
	move.w	#$57,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Flopfmt virgin,magic,intlv,side,track,spt,dev,skew,buf
	move.w	virgin,-(sp)
	move.l	magic,-(sp)
	move.w	intlv,-(sp)
	move.w	side,-(sp)
	move.w	track,-(sp)
	move.w	spt,-(sp)
	move.w	dev,-(sp)	
	move.l	skew,-(sp)
	move.l	buf,-(sp)
	move.w	#$0a,-(sp)
	trap	#xbios
	lea	26(sp),sp
.endm

.macro Floprate rate,dev
	move.w	rate,-(sp)
	move.w	dev,-(sp)
	move.w	#$29,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Floprd count,side,track,sector,dev,buf
	move.w	count,-(sp)
	move.w	side,-(sp)
	move.w	track,-(sp)
	move.w	sector,-(sp)
	move.w	dev,-(sp)
	clr.l	-(sp)
	move.l	buf,-(sp)
	move.w	#$08,-(sp)
	trap	#xbios
	lea	20(sp),sp
.endm

.macro Flopver count,side,track,sector,dev,buf
	move.w	count,-(sp)
	move.w	side,-(sp)
	move.w	track,-(sp)
	move.w	sector,-(sp)
	move.w	dev,-(sp)
	clr.l	-(sp)
	move.l	buf,-(sp)
	move.w	#$13,-(sp)
	trap	#xbios
	lea	20(sp),sp
.endm

.macro Flopwr count,side,track,sector,dev,buf
	move.w	count,-(sp)
	move.w	side,-(sp)
	move.w	track,-(sp)
	move.w	sector,-(sp)
	move.w	dev,-(sp)
	clr.l	-(sp)
	move.l	buf,-(sp)
	move.w	#$09,-(sp)
	trap	#xbios
	lea	20(sp),sp
.endm

.macro Getrez
	move.w	#$04,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Gettime
	move.w	#$17,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Giaccess register,data
	move.w	register,-(sp)
	move.w	data,-(sp)
	move.w	#$1c,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Gpio data,mode
	move.w	data,-(sp)
	move.w	mode,-(sp)
	move.w	#$8a,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Ikbdws buf,len
	move.l	buf,-(sp)
	move.w	len,-(sp)
	move.w	#$19,-(sp)
	trap	#xbios
	addq.l	#8,sp
.endm

.macro Initmous hand,param,mode
	move.l	hand,-(sp)
	move.l	param,-(sp)
	move.w	mode,-(sp)
	clr.w	-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Iorec dev
	move.w	dev,-(sp)
	move.w	#$0e,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Jdisint intno
	move.w	intno,-(sp)
	move.w	#$1a,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Jenabint intno
	move.w	intno,-(sp)
	move.w	#$1b,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Kbdvbase
	move.w	#$22,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Kbrate rate,delay
	move.w	rate,-(sp)
	move.w	delay,-(sp)
	move.w	#$23,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Keytbl caps,shift,normal
	move.l	caps,-(sp)
	move.l	shift,-(sp)
	move.l	normal,-(sp)
	move.w	#$10,-(sp)
	trap	#xbios
	lea	14(sp),sp
.endm

.macro Locksnd
	move.w	#$80,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Logbase
	move.w	#$03,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Metainit metainfo
	move.l	metainfo,-(sp)
	move.w	#$30,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Mfpint vector,intno
	move.l	vector,-(sp)
	move.w	intno,-(sp)
	move.w	#$0d,-(sp)
	trap	#xbios
	addq.l	#8,sp
.endm

.macro Midiws buf,count
	move.l	buf,-(sp)
	move.w	count,-(sp)
	move.w	#$0c,-(sp)
	trap	#xbios
	addq.l	#8,sp
.endm

.macro NVMaccess buffer,count,start,op
	move.l	buffer,-(sp)
	move.w	count,-(sp)
	move.w	start,-(sp)
	move.w	op,-(sp)
	move.w	#$2e,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Offgibit mask
	move.w	mask,-(sp)
	move.w	#$1d,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Ongibit mask
	move.w	mask,-(sp)
	move.w	#$1e,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Physbase
	move.w	#$02,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Protobt execflag,type,serial,buf
	move.w	execflag,-(sp)
	move.w	type,-(sp)
	move.l	serial,-(sp)
	move.l	buf,-(sp)
	move.w	#$12,-9sp)
	trap	#xbios
	lea	14(sp),sp
.endm

.macro Prtblk prtblk
	move.l	prtblk,-(sp)
	move.w	#$24,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Puntaes
	move.w	#$27,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Random
	move.w	#$11,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Rsconf scr,tsr,rsr,ucr,flow,speed
	move.w	scr,-(sp)
	move.w	tsr,-(sp)
	move.w	rsr,-(sp)
	move.w	ucr,-(sp)
	move.w	flow,-(sp)
	move.w	speed,-(sp)
	move.w	#$0f,-(sp)
	trap	#xbios
	lea	14(sp),sp
.endm

.macro Scrdmp
	move.w	#$14,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro Setbuffer endaddr,begaddr,mode
	move.l	endaddr,-(sp)
	move.l	begaddr,-(sp)
	move.w	mode,-(sp)
	move.w	#$83,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Setcolor new,idx
	move.w	new,-(sp)
	move.w	idx,-(sp)
	move.w	#$06,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Setinterrupt cause,mode
	move.w	cause,-(sp)
	move.w	mode,-(sp)
	move.w	#$87,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Setmode mode
	move.w	mode,-(sp)
	move.w	#$84,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Setmontracks track
	move.w	track,-(sp)
	move.w	#$86,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Setpalette palette
	move.l	palette,-(sp)
	move.w	#$06,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Setprt new
	move.w	new,-(sp)
	move.w	#$33,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Setscreen mode,phys,log
	move.w	mode,-(sp)
	move.l	phys,-(sp)
	move.l	log,-(sp)
	move.w	#$05,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro Settime time
	move.l	time,-(sp)
	move.w	#$16,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Settracks rectracks,playtracks
	move.w	rectracks,-(sp)
	move.w	playtracks,-(sp)
	move.w	#$85,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Sndstatus reset
	move.w	reset,-(sp)
	move.w	#$8c,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Soundcmd data,mode
	move.w	data,-(sp)
	move.w	mode,-(sp)
	move.w	#$82,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Ssbrk len
	move.w	len,-(sp)
	move.w	#$01,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Supexec func
	move.l	func,-(sp)
	move.w	#$26,-(sp)
	trap	#xbios
	addq.l	#6,sp
.endm

.macro Unlocksnd
	move.w	#$81,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro VgetMonitor
	move.w	#$59,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro VgetRGB rgb,count,index
	move.l	rgb,-(sp)
	move.w	count,-(sp)
	move.w	index,-(sp)
	move.w	#$5e,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro Vgetsize mode
	move.w	mode,-(sp)
	move.w	#$5b,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro VsetMask overlay,andmask,ormask
	move.w	overlay,-(sp)
	move.l	andmask,-(sp)
	move.l	ormask,-(sp)
	move.w	#$92,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.macro VsetMode mode
	move.w	mode,-(sp)
	move.w	#$58,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro VsetRGB rgb,count,index
	move.l	rgb,-(sp)
	move.w	count,-(sp)
	move.w	index,-(sp)
	move.w	#$5d,-(sp)
	trap	#xbios
	lea	10(sp),sp
.endm

.macro VsetScreen modecode,mode,phys,log
	move.w	modecode,-(sp)
	move.w	mode,-(sp)
	move.l	phys,-(sp)
	move.l	log,-(sp)
	move.w	#$05,-(sp)
	trap	#xbios
	lea	14(sp),sp
.endm

.macro VsetSync external
	move.w	external,-(sp)
	move.w	#$5a,-(sp)
	trap	#xbios
	addq.l	#4,sp
.endm

.macro Vsync
	move.w	#$25,-(sp)
	trap	#xbios
	addq.l	#2,sp
.endm

.macro WavePlay slen,sptr,rate,flags
	move.l	slen,-(sp)
	move.l	sptr,-(sp)
	move.l	rate,-(sp)
	move.w	flags,-(sp)
	move.w	#$a5,-(sp)
	trap	#xbios
	lea	16(sp),sp
.endm

.macro Xbtimer hand,data,control,timer
	move.l	hand,-(sp)
	move.w	data,-(sp)
	move.w	control,-(sp)
	move.w	timer,-(sp)
	move.w	#$1f,-(sp)
	trap	#xbios
	lea	12(sp),sp
.endm

.endif