; /-----------------------------------------------------------------------/
; file:		xlib.i
; function:	declaration of calls to (macro's)
; opcode:		
; part of:	General Merciful Software development.
;
; author:		E Kuik
; company:	Merciful Software (1997)
; /-----------------------------------------------------------------------/

; Ronald:
; This is the main lib including I'm using. Not all call declared here
; are present in the program, but you may need it for the macro's.

.ifnb _xlib_

_xlib	=	1

.include "tos.i"
;.include "gem.i"		; not needed for netname
;.include "icolib.i"	; not needed for netname

Contrl	=	0
Global	=	4
Intin	=	8
Intout	=	12
Addrin	=	16
Addrout	=	20

xbra	=	"XBRA"	; Xbra protocol
appl	=	"_APP"	; notify that vector is in use by a applicaton

true	=	1
false	=	0
TRUE	=	true
FALSE	=	false

_d_secrsc	=	$0800		/* second resource flag */

; sysinf struct
xlib_ws	=	0	; library ws handle
xlib_mem	=	2	; librarys memory base
xlib_mems	=	6	; librarys memory size
apid	=	10	; application's id
apmn	=	12	; application's menu entry number
scr_w	=	14	; width of screen in pixel
scr_h	=	16	; heigth of screen in pixel
tos_v	=	18	; tos version
dos_v	=	20	; gemdos version
aes_v	=	22	; aes version
gdos_v	=	24	; Gdos version
mfreest	=	26	; free memory left after library init (st ram)
mfreett	=	30	; free memory left after library init (tt ram)
fonts	=	34	; extra fonts loaded
xlib_wbuf	=	38	; pointer to window buffers
xlib_wsiz	=	42	; size of window buffer
xlib_sbuf	=	46	; pointer to screen buffer
xlib_ssiz	=	50	; size of screen buffer
xlib_sndb	=	54	; pointer to sound sample buffer (in st ram)
xlib_sndz	=	58	; sound buffer size
fontb	=	62	; pointer to font names

; stuff for events
evnt_events	=	66	; requested events
evnt_bclick	=	68	; button clicks
evnt_bside	=	70	; left our right button
evnt_updown	=	72	; button up our down
evnt_rec1f	=	74	; in out rectangle flag
evnt_rect1	=	76	; rectangle 1
evnt_rec2f	=	84	; in out rectangle flag
evnt_rect2	=	86	; rectangle 2
evnt_ltime	=	94	; timer low
evnt_htime	=	96	; timer high
evnt_msg		=	98	; mesag buffer
evnt_evnt		=	116	; event happend
evnt_mx		=	118	; mouse x
evnt_my		=	120	; mouse y
evnt_mb		=	122	; mouse button state
evnt_ks		=	124	; keyboard state
evnt_kc		=	126	; keyboard key
evnt_mc		=	128	; mouse clicks

sysinf	=	192	; size of sysinf struct

/* internal rsc */
.ifnb _INTRSC_
	.include "..\xlib\system\xlib_rsc.i"
	.include "..\xlib\system\xlib_ico.i"
	_INTRSC_	=	1
.endif

/* alert elements */

ALRT_CLOSER	=	1
ALRT_TITLE	=	2
ALRT_ALLICONIFY	=	4
ALRT_ICONIFY	=	8
ALRT_HELP		=	16

.endif

.text
.macro if_true reg,opt
	cmp.w	#true,reg
	beq	opt
.endm

.macro if_ntrue reg,opt
	cmp.w	#true,reg
	bne	opt
.endm

.macro if_false reg,opt
	tst.w	reg
	beq	opt
.endm

.macro if_nfalse reg,opt
	tst.w	reg
	bne	opt
.endm

.macro push reg
	move.l	reg,-(sp)
.endm

.macro pull reg
	move.l	(sp)+,reg
.endm

.macro Push regs
	movem.l	regs,-(sp)
.endm

.macro Pull regs
	movem.l	(sp)+,regs
.endm

.macro Aesvar index,reg
	lea	aespb,reg
	move.l	index(reg),reg
.endm

/* ------------------ */
.macro Xinit reg
	lea	_sysinf,reg
	move.l	(reg),reg
.endm

.macro Xlib_init sysinf,appname1,appname2,status
	move.l	sysinf,a5
	move.l	appname2,-(sp)
	move.l	appname1,-(sp)
	jsr	_xinit
	addq.l	#8,sp
	move.w	intout,status
.endm

.macro Xlib_ini2 sysinf,status
	move.l	sysinf,a5
	jsr	_xinit2
	move.w	intout,status
.endm

.macro Xlib_exit sysinf
	move.l	sysinf,a5
	jsr	_xexit
.endm

.macro Xlib_exi2 sysinf
	move.l	sysinf,a5
	jsr	_xexit2
.endm

.macro Xerror
	Aesvar	Intout,a0
	move.w	#0,(a0)
	rts
.endm

.macro Xok
	Aesvar	Intout,a0
	move.w	#1,(a0)
	rts
.endm

.macro Xlink reg,dat
	pea	(reg)
	move.l	sp,reg
	add.l	dat,sp
	pea	(reg)
	move.l	dat,d0
	lea	0(reg,d0.l),reg
.endm

.macro Xunlk reg
	move.l	(sp)+,reg
	move.l	reg,sp
	move.l	(sp)+,reg
.endm

.macro Xrsc_load fname,rsc_id
	Aesvar	Addrin,a0
	move.l	fname,(a0)
	jsr	_rsrc_load
	Aesvar	Intout,a0
	move.w	(a0),rsc_id
.endm

.macro Xrsc_fix base,size,rsc_id
	Aesvar	Addrin,a0
	move.l	#0,(a0)
	move.l	base,4(a0)
	move.l	size,8(a0)
	jsr	_rsrc_load
	Aesvar	Intout,a0
	move.w	(a0),rsc_id
.endm

.macro Xrsc_unld rsc_id
	Aesvar	Intin,a0
	move.w	rsc_id,(a0)
	jsr	_rsrc_free
.endm

.macro Xrsc_cnvrt mode,src_id,list,dst_id
	Aesvar	Intin,a0
	move.w	mode,(a0)		; 0 keep src rsc / 1 unload src rsc
	move.w	src_id,2(a0)
	Aesvar	Addrin,a0
	move.l	list,0(a0)
	jsr	_rsrc_convert
	Aesvar	Intout,a0
	move.w	0(a0),dst_id
.endm.

.macro Xrsc_gaddr type,index,rsc_id,adr
	Aesvar	Intin,a0
	move.w	type,(a0)
	move.w	index,2(a0)
	move.w	rsc_id,4(a0)
	jsr	_xrsc_gaddr
	Aesvar	Intout,a0
	move.w	(a0),d0
	move.l	2(a0),adr
.endm

.macro Xrsc_obcnv id1,tree,obj,id2,ico
	Aesvar	Intin,a0
	move.w	id1,(a0)
	move.w	tree,2(a0)
	move.w	obj,4(a0)
	move.w	id2,6(a0)
	move.w	ico,8(a0)
	jsr	_xrsc_obconvert
	Aesvar	Intout,a0
	move.w	(a0),d0
.endm

.macro Xfnt_srch name,id
	Aesvar	Addrin,a0
	move.l	name,(a0)
	jsr	Font_search
	Aesvar	Intout,a0
	move.w	(a0),id
.endm

.macro Ico2Icn Ico,buff,colors,mused,status
	move.l	Ico,a0
	move.l	buff,a1
	move.w	colors,d0
	jsr	ico2cicon
	move.l	d0,mused
	Aesvar	Intout,a0
	move.w	(a0),status
.endm

.macro Xfsel_inp path,fname,pname,messag,status
	pea	messag
	pea	pname
	pea	fname
	pea	path
	jsr	_Xfsel_input
	lea	16(sp),sp
	move.w	d0,status
.endm

.macro X_event event,msg_buff
	Aesvar	Intin,a0
	move.w	event,(a0)
	jsr	_xevnt_multi
	Aesvar	Addrout,a0
	move.l	(a0),msg_buff
	move.l	4(a0),a0		; sys pointer
	move.w	evnt_evnt(a0),event
.endm

/* Also include window macros */
.include "xwindow.i"

/* And Pure_C library access */
.include "pure_c.i"


/* customized aes calls */
.macro Xform_keybd tree,obj,nextobj,kc,ks,idx,newobj,keyout,nidx
	Save	a0
	Aesvar	Intin,a0
	move.w	obj,(a0)
	move.w	nextobj,2(a0)
	move.w	kc,4(a0)
	move.w	ks,6(a0)
	move.w	idx,8(a0)
	Aesvar	Addrin,a0
	move.l	tree,(a0)
	jsr	_xform_keybd
	Aesvar	Intout,a0
	move.w	2(a0),newobj
	move.w	4(a0),keyout
	move.w	6(a0),nidx
	move.w	(a0),d0
	Restore	a0
.endm

.macro Xobjc_edit tree,obj,kc,idx,mode
	Save	a0
	Aesvar	Intin,a0
	move.w	obj,(a0)
	move.w	kc,2(a0)
	move.w	idx,4(a0)
	move.w	mode,6(a0)
	Aesvar	Addrin,a0
	move.l	tree,(a0)
	jsr	_xobjc_edit
	Restore	a0
.endm

.macro X_alert defb,string,elements,font,input
	Aesvar	Intin,a0
	move.w	defb,(a0)
	move.w	elements,2(a0)
	move.w	font,4(a0)
	Aesvar	Addrin,a0
	move.l	string,(a0)
	jsr	_xalert
	Aesvar	Intout,a0
	move.w	(a0),input
.endm