;----------------------------------------------------------------------------
;File name:	MAKEBOOT.S			Revision date:	1998.06.21
;Created by:	Ulf Ronald Andersson		Creation date:	1997.03.14
;----------------------------------------------------------------------------
	include	"uran\STRUCT.SH"
	include	"uran\URAn_SYS.SH"
	include	"uran\URAn_DOS.SH"
;----------------------------------------------------------------------------
	.TEXT
;----------------------------------------------------------------------------
start:
	move.l	4(sp),a5
	lea	loc_st_top(pc),sp
;
	move.l	bp_bss_beg_p(a5),d0
	add.l	bp_bss_len(a5),d0
	sub.l	a5,d0
	gemdos	Mshrink,#0,(a5),d0
;
main_loop:
	gemdos	Cconws,main_msg_s(pc)
;
command_loop:
	gemdos	Crawcin
	cmp.b	#$2A,D0
	beq.s	go_ahead		;<*> => write bootsector on A:
	cmp.b	#ESC,D0
	bne.s	command_loop		;unrecognized => loop
	gemdos	Pterm0			;<escape> => exit program
;
;------------------------------------
;
go_ahead:
	gemdos	Fopen,boot_sec_bs_s(pc),#0
	move.l	d0,d7
	ble.s	file_error
	gemdos	Fread,d7,#$300,new_sector(pc)
	move.l	d0,d6
	gemdos	Fclose,d7
	move.l	d6,d0
	ble.s	file_error
	cmp.l	#$200,d0
	beq.s	file_ok
file_error:
	gemdos	Cconws,file_error_s(pc)
	bra	space_wait
;
file_ok:
	xbios	Floprd,old_sector(pc),#0,#0,#1,#0,#0,#1
	tst.w	D0
	bne.s	.failure
	lea	old_sector+bs_filler(pc),a0
	lea	new_sector+bs_filler(pc),a1
	moveq	#28-1,d5
.copy_disk_bpb:
	move.b	(A0)+,(A1)+
	dbra	D5,.copy_disk_bpb
;
	xbios	Protobt,new_sector(pc),#-1,#-1,#1
	xbios	Flopwr,new_sector(pc),#0,#0,#1,#0,#0,#1
;
	tst.w	D0
	beq.s	.success
.failure:
	gemdos	Cconws,error_msg_s(pc)
	bra.s	space_wait
;
.success:
	gemdos	Cconws,success_msg_s(pc)
space_wait:
	gemdos	Crawcin
	cmp.b	#' ',D0
	bne.s	space_wait
	bra	main_loop
;
;----------------------------------------------------------------------------
error_msg_s:
	dc.b	ESC,'E'
	dc.b	ESC,'p'
	dc.b	'     An error has occured, please      ',ESC,'q',CR,LF
	dc.b	ESC,'p'
	dc.b	'     check the disk in drive A.        ',ESC,'q',CR,LF
	dc.b	'An error happens if your disk is write'
	dc.b	'protected, unformatted or faulty.',CR,LF
	dc.b	CR,LF
	dc.b	'Press ',ESC,'p','<space>',ESC,'q',' when done reading.',CR,LF,NUL
;----------------------------------------------------------------------------
file_error_s:
	dc.b	ESC,'E'
	dc.b	ESC,'p'
	dc.b	'     A file error has occured, please  ',ESC,'q',CR,LF
	dc.b	ESC,'p'
	dc.b	'     use a proper 512 byte file.       ',ESC,'q',CR,LF
	dc.b	CR,LF
	dc.b	'Press ',ESC,'p','<space>',ESC,'q',' when done reading.',CR,LF,NUL
;----------------------------------------------------------------------------
;
success_msg_s:
	dc.b	ESC,'E'
	dc.b	CR,LF
	dc.b	CR,LF
	dc.b	CR,LF
	dc.b	'Bootsector written without error.',CR,LF,CR,LF
	dc.b	'Press ',ESC,'p','<space>',ESC,'q',' to continue.',CR,LF,NUL
;
;----------------------------------------------------------------------------
;
main_msg_s:
	dc.b	ESC,'E'
	dc.b	CR,LF
	dc.b	'This program places a  bootsector on',CR,LF
	dc.b	'diskettes in drive A when you  press',CR,LF
	dc.b	'the asterisk key  ',ESC,'p','<*>',ESC,'q','  to do so, but',CR,LF
	dc.b	'you can exit  without  affecting any',CR,LF
	dc.b	'diskette by pressing  ',ESC,'p','<escape>',ESC,'q','.',CR,LF
	dc.b	CR,LF
	dc.b	CR,LF,NUL
;
boot_sec_bs_s:
	dc.b	'boot_sec.bs'
;
	.EVEN
;----------------------------------------------------------------------------
	.BSS
;----------------------------------------------------------------------------
;
new_sector:
	ds.l	2048/4
	ds.l	512/4
old_sector:
	ds.l	512/4
;
local_stack:
	ds.l	256
loc_st_top:
;
;----------------------------------------------------------------------------
	.END
;----------------------------------------------------------------------------
;End of file:	MAKEBOOT.S
;----------------------------------------------------------------------------
