;----------------------------------------------------------------------------
;File name:	SEEMEM_B.S			Revision date:	1998.07.25
;Created by:	Ulf Ronald Andersson		Creation date:	1997.03.14
;----------------------------------------------------------------------------
	include	"uran\STRUCT.SH"
	include	"uran\URAn_SYS.SH"
	include	"uran\URAn_DOS.SH"
	include	"bs_comp\TRACER.SH"
;----------------------------------------------------------------------------
	.TEXT
;----------------------------------------------------------------------------
code_beg:
	bra.s	main_code	;boot sector code link
;----------------------------------------------------------------------------
	ds.b	28		;boot sector parts reserved for BIOS use
;----------------------------------------------------------------------------
main_code:
	dc.w	$a000		;a0 -> line_a variable base
	include	"bs_comp\seemem.s"
;----------------------------------------------------------------------------
code_end:
code_size	=	code_end-code_beg
;----------------------------------------------------------------------------
.MACRO	sz_pad	id,limit,pos
.IF	pos < limit
	dcb.b		limit-pos,0
	sz_pad_padded	id,$(limit-pos)
.ELSE
.IF	pos == limit
	sz_pad_exact	id
.ELSE
	sz_pad_error	id,$(pos-limit)
.ENDIF
.ENDIF
.ENDM	sz_pad
;
.MACRO	sz_pad_exact	id
	.PRINT	'&id had exactly the right size. OK!'
.ENDM	sz_pad_exact
;
.MACRO	sz_pad_error	id,value
	.ERROR	'&id was too large by &value bytes.'
.ENDM	sz_pad_error
;
.MACRO	sz_pad_padded	id,value
	.PRINT	'&id was padded by &value bytes. OK!'
.ENDM	sz_pad_padded
;----------------------------------------------------------------------------
	sz_pad	boot_sector,510,code_size
;
checksum:
	dc.w	0
;----------------------------------------------------------------------------
booter_end:
;----------------------------------------------------------------------------
	.END
;----------------------------------------------------------------------------
;End of file:	SEEMEM_B.S
;----------------------------------------------------------------------------
