;----------------------------------------------------------------------------
;File name:	AUTOSTUF.S			Revision date:	1998.06.01
;Created by:	Ulf Ronald Andersson		Creation date:	1996.04.25
;----------------------------------------------------------------------------
;
revision	equ	$13
interface	equ	$13
;
;----------------------------------------------------------------------------
;Required header declarations:
;
	.include	"uran\STRUCT.SH"	;PASM adapted structures
	.include	"uran\URAn_SYS.SH"	;Main system definitions
	.include	"uran\URAn_LA.SH"	;Line A variables etc
	.include	"uran\URAn_DOS.SH"	;GEMDOS, BIOS, XBIOS
	.include	"uran\URAn_JAR.SH"	;Cookie jar handling
	.include	"uran\URAn_XB.SH"	;XBRA protocol
;
;----------------------------------------------------------------------------
	.TEXT
;----------------------------------------------------------------------------
;Start of:	TSR resident program
;----------------------------------------------------------------------------
text_beg:
rz:	;relative reference zero point
bp	=	rz-$100
;----------------------------------------------------------------------------
start:
	jmp	(init_main).l	;cookie+$0100
;
	dc.l	'Stuf'		;cookie+$0106
	dc.w	revision	;cookie+$010A
	dc.w	interface	;cookie+$010C
;
;----------------------------------------------------------------------------
;Start of:	TSR resident data
;----------------------------------------------------------------------------
line_a_base_p:	ds.l	1
tos_version:	ds.w	1
new_tos_f:	ds.w	1
kbshift_p:	ds.l	1
currbp_p_p:	ds.l	1
;----------------------------------------------------------------------------
;End of:	TSR resident data
;----------------------------------------------------------------------------
;Start of:	TSR resident cookie jar routines & data
;----------------------------------------------------------------------------
;
	_uniref	reset_old_jar
	make	JAR_links
;
;----------------------------------------------------------------------------
;End of:	TSR resident cookie jar routines & data
;----------------------------------------------------------------------------
;End of:	TSR resident program
;----------------------------------------------------------------------------
reside_end:
;----------------------------------------------------------------------------
;Start of:	non-resident initialization routines
;----------------------------------------------------------------------------
;
init_main:
	move.l	#E~ERROR,d0
	move.l	a0,d1
	bne.s	.Pterm_d0
	move.l	4(sp),a5		;a5 -> basepage
	move.l	d0,init_error-bp(a5)
	lea	init_stack_top(pc),sp	;sp -> local stack
	lea	initial_end(pc),a0
	sub.l	a5,a0
	gemdos	Mshrink,#0,(a5),a0	;release unused RAM
	xbios	Supexec,init_main_supx(pc)
	move.l	init_error(pc),d0
	bpl.s	.exit_TSR
.Pterm_d0:
	gemdos	Pterm,d0
;
;------------------------------------
;
.exit_TSR:
	lea	reside_end(pc),a0
	sub.l	a5,a0
	gemdos	Ptermres,a0,#0
;
;----------------------------------------------------------------------------
;
init_main_supx:
	lea	bp(pc),a5
	eval_cookie	#'Stuf'
	bpl	.exit
	make_cookie	#'Stuf',a5
	bmi	.exit
	clr.l	init_error-bp(a5)
;
	_a_init
	move.l	d0,line_a_base_p
;
	xbios	Keytbl,-1.w,-1.w,-1.w
	move.l	d0,a0
	lea	-1(a0),a0	;NB: this assumes Kbshift stored at Keytbl-1
	move.l	a0,kbshift_p	;NB: So all early TOS have Kbshift data at Keytbl-1 !!!
;
	move.l	#TOS_100_currbp_p,currbp_p_p
;
	move.l	(_sysbase).w,a0
	move.l	os_selfbeg_p(a0),a0
	move	os_version(a0),d0
	move	d0,tos_version
	clr	new_tos_f
	cmp	#$0104,d0
	shs	new_tos_f
	cmp	#$0100,d0
	bls.s	.done_TOS_fix
;patch TOS 1.02 fix here (if needed)
	move.l	os_currbp_p_p(a0),currbp_p_p
	move.l	os_kbshift_p(a0),kbshift_p
.done_TOS_fix:
.exit:
	rts
;
init_error:	ds.l	1
;
;----------------------------------------------------------------------------
;End of:	non-resident initialization routines
;----------------------------------------------------------------------------
;Start of:	non-resident library routines
;----------------------------------------------------------------------------
;
	make	JAR_links
;
;----------------------------------------------------------------------------
;End of:	non-resident library routines
;----------------------------------------------------------------------------
	dc.l	data_beg
	dc.l	data_end
text_end:
text_size	=	text_end-text_beg
;----------------------------------------------------------------------------
	.DATA
;----------------------------------------------------------------------------
data_beg:
data_end:
data_size	=	data_end-data_beg
;----------------------------------------------------------------------------
	.BSS
;----------------------------------------------------------------------------
;
bss_beg:
init_stack:	ds.l	128
init_stack_top:
;
initial_end:
bss_end:
bss_size	=	bss_end-bss_beg
;----------------------------------------------------------------------------
	.END
;----------------------------------------------------------------------------
;End of file:	AUTOSTUF.S
;----------------------------------------------------------------------------
